module.exports = {
  guides: [
    "guides/guides-overview",
    "guides/introduction",
    "guides/quick-start",
    "guides/basic-examples",
    "guides/describing-data",
    "guides/extracting-data",
    {
      "Validating Data": [
        "guides/validation-guide",
        "guides/validation-checks",
      ],
    },
    {
      "Transforming Data": ["guides/transform-guide", "guides/transform-steps"],
    },
    {
      "Mastering the Framework": [
        "guides/framework/package-guide",
        "guides/framework/resource-guide",
        "guides/framework/schema-guide",
        "guides/framework/field-guide",
        "guides/framework/layout-guide",
        "guides/framework/detector-guide",
        "guides/framework/inquiry-guide",
        "guides/framework/report-guide",
        "guides/framework/pipeline-guide",
        "guides/framework/status-guide",
      ],
      "Writing an Extension": [
        "guides/extension/design-guide",
        "guides/extension/plugin-guide",
        "guides/extension/scheme-guide",
        "guides/extension/format-guide",
        "guides/extension/check-guide",
        "guides/extension/step-guide",
        "guides/extension/type-guide",
        "guides/extension/error-guide",
        "guides/extension/server-guide",
        "guides/extension/storage-guide",
      ],
    },
    "guides/whats-next",
  ],
  tutorials: [
    "tutorials/tutorials-overview",
    "tutorials/working-in-python",
    "tutorials/working-with-cli",
    "tutorials/working-with-api",
    {
      "Schemes Tutorials": [
        "tutorials/schemes/buffer-tutorial",
        "tutorials/schemes/local-tutorial",
        "tutorials/schemes/multipart-tutorial",
        "tutorials/schemes/remote-tutorial",
        "tutorials/schemes/s3-tutorial",
        "tutorials/schemes/stream-tutorial",
      ],
      "Formats Tutorials": [
        "tutorials/formats/bigquery-tutorial",
        "tutorials/formats/ckan-tutorial",
        "tutorials/formats/csv-tutorial",
        "tutorials/formats/excel-tutorial",
        "tutorials/formats/gsheets-tutorial",
        "tutorials/formats/html-tutorial",
        "tutorials/formats/inline-tutorial",
        "tutorials/formats/json-tutorial",
        "tutorials/formats/ods-tutorial",
        "tutorials/formats/pandas-tutorial",
        "tutorials/formats/spss-tutorial",
        "tutorials/formats/sql-tutorial",
      ],
    },
    "tutorials/whats-next",
  ],
  references: [
    "references/references-overview",
    "references/plugins-reference",
    "references/schemes-reference",
    "references/formats-reference",
    "references/errors-reference",
    "references/checks-reference",
    "references/steps-reference",
    "references/types-reference",
    "references/api-reference",
    "references/whats-next",
  ],
  development: [
    "development/development",
    "development/changelog",
    "development/migration",
    "development/authors",
    "development/contributing",
    "development/whats-next",
  ],
};
